=== modified file 'drizzled/drizzled.cc'
--- drizzled/drizzled.cc	2010-12-26 22:31:33 +0000
+++ drizzled/drizzled.cc	2010-12-30 17:09:51 +0000
@@ -37,6 +37,7 @@
 #include <boost/thread/shared_mutex.hpp>
 #include <boost/thread/condition_variable.hpp>
 #include <boost/filesystem.hpp>
+#include <boost/detail/atomic_count.hpp>
 
 #include "drizzled/internal/my_sys.h"
 #include "drizzled/internal/my_bit.h"
@@ -351,7 +352,7 @@
 
 passwd *user_info;
 
-atomic<uint32_t> connection_count;
+boost::detail::atomic_count connection_count(0);
 
 global_buffer_constraint<uint64_t> global_sort_buffer(0);
 global_buffer_constraint<uint64_t> global_join_buffer(0);
@@ -637,7 +638,7 @@
 
 void drizzled::Session::unlink(Session::shared_ptr &session)
 {
-  connection_count.decrement();
+  --connection_count;
 
   session->cleanup();
 
@@ -2196,8 +2197,6 @@
 #else
   have_symlink=SHOW_OPTION_YES;
 #endif
-
-  connection_count= 0;
 }
 
 

=== modified file 'drizzled/drizzled.h'
--- drizzled/drizzled.h	2010-12-18 04:43:40 +0000
+++ drizzled/drizzled.h	2010-12-30 17:09:51 +0000
@@ -24,9 +24,11 @@
 #include <bitset>
 #include <boost/program_options.hpp>
 
-#include "drizzled/atomics.h"
+#include <boost/detail/atomic_count.hpp>
+
 #include "drizzled/global_buffer.h"
 #include "drizzled/definitions.h"
+
 struct passwd;
 
 namespace drizzled
@@ -38,7 +40,7 @@
 }
 
 extern std::bitset<12> test_flags;
-extern atomic<uint32_t> connection_count;
+extern boost::detail::atomic_count connection_count;
 extern const char *load_default_groups[];
 extern bool volatile select_thread_in_use;
 extern bool volatile abort_loop;

=== modified file 'drizzled/session.cc'
--- drizzled/session.cc	2010-12-25 01:27:46 +0000
+++ drizzled/session.cc	2010-12-31 01:43:36 +0000
@@ -571,11 +571,13 @@
   arg->scheduler= plugin::Scheduler::getScheduler();
   assert(arg->scheduler);
 
-  connection_count.increment();
-
-  if (connection_count > current_global_counters.max_used_connections)
+  ++connection_count;
+
+  long current_connections= connection_count;
+
+  if (current_connections > 0 and static_cast<uint64_t>(current_connections) > current_global_counters.max_used_connections)
   {
-    current_global_counters.max_used_connections= connection_count;
+    current_global_counters.max_used_connections= static_cast<uint64_t>(connection_count);
   }
 
   current_global_counters.connections++;

